// i30tosyx  by Gnter Nagler Oct 1998
#include <stdio.h>
#include <string.h>
#include "filei3.hpp"

int splitsyx = 0;

char i30name[80];
char syxname[80];

int sysexencode(FILE* bit8, FILE* bit7, long len = -1)
{
  while (len != 0)
  {
    unsigned char bit8data[7];
    unsigned char bit7data[8];
    int cnt = 7;
    if (len >= 0 && len < cnt)
      cnt = (int)len;
    int n = fread(bit8data, 1, cnt, bit8);
    if (n <= 0)
      break;
    if (len > 0)
      len -= cnt;
    // 7 bytes to 8 codes
    int n7bit = code7to8(bit8data, n, bit7data);
    if (fwrite(bit7data, n7bit, 1, bit7) != 1)
      return 1;
  }
  return 0;
}

int sng2syx(FILE* sngf, FILE* syxf)
{
  fseek(sngf, 0x2c, SEEK_SET);
  unsigned num = getw(sngf);
  fseek(sngf, 96, SEEK_SET);

  fputc(0xf0, syxf);
  fputc(0x42, syxf);
  fputc(0x30, syxf);
  fputc(0x49, syxf);
  fputc(0x48, syxf);
  fputc(num % 128, syxf);
  fputc(num / 128, syxf);
  int ret = sysexencode(sngf, syxf);
  fputc(0xf7, syxf);
  return ret;
}

int bsq2syx(FILE* bsqf, FILE* syxf)
{
  fseek(bsqf, 0x2c, SEEK_SET);
  unsigned num = getw(bsqf);
  fseek(bsqf, 96, SEEK_SET);

  fputc(0xf0, syxf);
  fputc(0x42, syxf);
  fputc(0x30, syxf);
  fputc(0x49, syxf);
  fputc(0x66, syxf);
  fputc(num % 128, syxf);
  fputc(num / 128, syxf);
  int ret = sysexencode(bsqf, syxf);
  fputc(0xf7, syxf);
  return ret;
}

int prg2syx(FILE* prgf, FILE* syxf)
{
  fseek(prgf, 0x30, SEEK_SET);

  fputc(0xf0, syxf);
  fputc(0x42, syxf);
  fputc(0x30, syxf);
  fputc(0x49, syxf);
  fputc(0x4C, syxf);
  int ret = sysexencode(prgf, syxf);
  fputc(0xf7, syxf);
  return ret;
}

int arr2syx(FILE* arrf, FILE* syxf)
{
  fseek(arrf, 0x20, SEEK_SET);

  fputc(0xf0, syxf);
  fputc(0x42, syxf);
  fputc(0x30, syxf);
  fputc(0x49, syxf);
  fputc(0x64, syxf);
  int ret = sysexencode(arrf, syxf);
  fputc(0xf7, syxf);
  return ret;
}

int sty2syx(FILE* styf, FILE* syxf)
{
  fseek(styf, 0x10, SEEK_SET);
  long firstofs;
  if (fread(&firstofs, 4, 1, styf) != 1)
    return 1;
  int count = fgetc(styf);
  count = (count << 8) + fgetc(styf);
  long pos = ftell(styf);
  int blocknr = 0;
  for (int i = 0; i < count; )
  {
    fseek(styf, pos, SEEK_SET);
    long ofs[4];
    unsigned len[4];
    int n = 0;
    ofs[0] = 0x20;
    long totalsize = 0x20;
    for (int j = 0; j < 4; j++)
    {
      int idx = fgetc(styf);
      int id = fgetc(styf); // 1
      len[j] = getw(styf);
      if (j > 0)
        ofs[j] = totalsize;
      totalsize += len[j];
      i++;
      n++;
    }
    pos = ftell(styf);
//    printf("block %d: %ld\n", blocknr+1, totalsize);
    if (totalsize > 0xffffL)
    {
      fprintf(stderr, "block is too large\n");
      return 1;
    }

    char tempname[14];
    sprintf(tempname, "temp%d.dat", blocknr+1);
    FILE* tempf = fopen(tempname, "wb");
    if (!tempf)
    {
      perror(tempname);
      return 1;
    }
    for (j = 0; j < n; j++)
    {
      fwrite(&ofs[j], 4, 1, tempf);
      fwrite(&len[j], 2, 1, tempf);
    }
    for (j = n * 6; j < 0x20; j++)
      fputc(0, tempf);

    fseek(styf, firstofs, SEEK_SET);
    long copylen = totalsize - 0x20;
    while (copylen-- > 0)
      fputc(fgetc(styf), tempf);
    firstofs += totalsize-0x20;
    fclose(tempf);
    tempf = fopen(tempname, "rb");
    if (!tempf)
    {
      perror(tempname);
      return 1;
    }

    if (splitsyx)
    {
      char stysyx[80];
      strcpy(stysyx, syxname);
      char* ext = strrchr(stysyx, '.');
      if (ext)
        *ext = 0;
      sprintf(ext, "%02d.syx", blocknr+1);
      syxf = fopen(stysyx, "wb");
    }

    fputc(0xf0, syxf);
    fputc(0x42, syxf);
    fputc(0x30, syxf);
    fputc(0x49, syxf);
    fputc(0x65, syxf);
    fputc(blocknr++, syxf);
    if (sysexencode(tempf, syxf) != 0)
      return 1;
    fclose(tempf);
    unlink(tempname);
    fputc(0xf7, syxf);

    if (splitsyx)
    {
      fclose(syxf);
      syxf = 0;
    }
  }
  return 0;
}

int main(int argc, char** argv)
{
  argc--; argv++;

  while (argc > 0 && **argv == '-')
  {
    if (strncmp(*argv, "-s", 2) == 0)
    {
      splitsyx = 1;
      argc--; argv++;
      continue;
    }
    fprintf(stderr, "invalid option %s\n", *argv);
    argc--; argv++;
  }

  if (argc < 2)
  {
    fprintf(stderr, "usage: i30tosyx [-s] i30file file.syx\n");
    fprintf(stderr, "-s\tsplit style syx into more files file01.syx ...\n");
    return 1;
  }
  strcpy(i30name, *argv++); argc--;
  FILE* i30f = fopen(i30name, "rb");
  if (!i30f)
  {
    perror(i30name);
    return 1;
  }
  char head[16];
  fread(head, 1, 16, i30f);
  if (strncmp(head, "KORG", 4) != 0 || strchr("IM", head[4]) == 0)
  {
    fprintf(stderr, "%s is not a KORG i30 or is40/is50 file\n", *argv);
    return 1;
  }
  FILE* syxf = 0;

  strcpy(syxname, *argv++); argc--;
  if (!splitsyx)
  {
    syxf = fopen(syxname, "wb");
    if (!syxf)
    {
      perror(syxname);
      return 1;
    }
  }
  int filetype = head[5];
  int subtype = head[6];
  int ret;
  switch(filetype)
  {
  case 5:
    if (subtype == 1)
      ret = sng2syx(i30f, syxf);
    else if (subtype == 0)
      ret = prg2syx(i30f, syxf);
    else if (subtype == 3)
      ret = arr2syx(i30f, syxf);
    else if (subtype == 4)
      ret = sty2syx(i30f, syxf);
    else if (subtype == 5)
      ret = bsq2syx(i30f, syxf);
    else
    {
      fprintf(stderr, "format %d subtype %d currently not supported\n", filetype, subtype);
      ret = 1;
    }

    break;
  default:
    fprintf(stderr, "format %d currently not supported\n", filetype);
    ret = 1;
    break;
  }

  if (syxf)
    fclose(syxf);
  fclose(i30f);
  return ret;
}
